
PG 1.12                                                 PG 1.12


NAME
        PG -- PaGer
        A text file viewer presented by FreeDOS

SYNOPSIS
        PG [/? | filename]
            /?       - display a brief help screen
            filename - page through filename on the PC screen
                     - filename maybe in wildcard format
            if filename is omitted, read data from <stdin>

        or  command | PG  like
            dir /s  | PG

DESCRIPTION
        PG is a text file viewer presented by the FreeDOS.
        It browses any text file and with more useful features now.
        Read this manual carefully to get the most from PG.
        With mouse support now!

CONTROL
        Control is intuitive, Keys defined as:

        PG Key      Meaning
        ======      =======
        Esc,Q,q     Exit program
        B,b         Toggle bit 7 on/off
        H,h         Hex view
        W,w         Wrap long lines
        Up          Scroll down 1 line
        Down,Enter  Scroll up 1 line
        Page Up     Scroll down 1 page
        Page Down   Scroll up 1 page
        Home        First page
        End         Last page
        Left        Pan view left 30 columns (1..256)
        Right       Pan view right 30 columns (1..256)
        1..5        Save current position to boomark #1..5
        Alt-1..5    Jump to saved bookmark
        Alt-D       Jump to DOS shell
        Backspace   Jump to a line as far as possible
        F1          Online help
        F2          Continue to search backward (Case Insensitive) (CI)
        F3          Continue to search forward  (CI)
        F4          Enter search mode and input search string (CI)
        S-F2        Continue to search backward (Case Sensitive) (CS)
        S-F3        Continue to search forward  (CS)
        F5          Save 1 screenful of text to "PG.SAV"
        C-PageUp    View previous file
        C-PageDn    View next file


        Bookmarks #1..5
            As you're viewing a text file, press any of the numeric
            keys 1..5 (under the Function keys), for instance, pressing
            '1' will save the top position of the file you're viewing to
            bookmark #1. Later on, when you want to return to the place
            where you left bookmark #1, just press 'Alt' and '1' brings
            you back no matter how far you've been.
            Bookmark #1 can be updated whenever you press '1' again.
            The same is true to other bookmark keys.

 Backspace  Jump to line
            Prompt user to enter a line number, then jump as far
            as possible.  Line number will be the top line and
            displayed at the end of the top status line.

        F1  Show you this manual by plugin

        F2  continues case insensitive search backward for the next
            occurrence, the line number appears at the bottom status
            line if the search is successful. It disappears if the
            search failed.

        F3  continues to search forward for the next occurrence,
            the line number appears at the bottom status line if
            the search is successful. It disappears if the search
            failed.

        F4  Search text
            Press F4 to enter search mode, you're prompted to input
            a string. The search start from the top line of your screen,
            then to next line and so on. Follow by
            F3 to search forward (CI);
            F2 to search backward (CI);
            Shift+F3 to search forward (CS);
            Shift+F2 to search backward (CS);
            If the string is found, the
            line number of the string found appears behind the
            search string.  If it is not found, nothing happens.
            Press F4 again to start a new search.

        F5  Save screen to "PG.SAV"
            When we're are viewing a file, sometimes, we want to get
            an extract from the source instead of retyping. PG helps
            us to save a screenful of text by pressing the F5 key,
            a message looks "!!! copy from filename line # !!!" will
            prepend the text we want to copy, and the file "PG.SAV",
            we need to tell PG which drive to save, just once.

    C-PgUp  Previous file
            To view the previous file from the list.

    C-PgDn  Next file
            To view the next file from the list.

MOUSE SUPPORT
        If mouse driver installed, PG and its plugins responds
        to the mouse event to perform certain tasks such as:
        1. right click at anywhere --> ESC exit;
        2. left click in upper part of screen --> page up;
        3. left click in lower part of the screen --> page down;
        4. left click at the top status line --> previous file;
        5. left click at the bottom status line --> next file;

COPYING
        This file and other related programs stored in PG112.ZIP are
        distributed under the terms of the GNU General Public License.
        See the file COPYING for details. And read the author's
        "Legal stuff" as written in the comments of the program
        source file.


What's new is version 1.12
        - Bug fixes after 1.11;
        - Mouse interface;
        - \x8 filtering;
        - reduce screen flickering;
        - remove redundant coding

Features
        - view very large file (1024*1024 lines);
        - multiple files viewing (256 in 1 directory);
        - top line is restored as viewing multiple files;
        - forward / reverse search (both sensitive and insensitive)
        - save screens to a save file;
        - view panning (max. 256 columns)
        - online help;
        - wrap long line
        - hex view
        - piping
        - 5 bookmarks
        - bit 7 on / off
        - jump to line;
        - jump to DOS shell
        - exclude file formats considered binary;
        - cursor appear over searched line;
        - simple user interface

        Read the news file for development details


Portability
        Operating Systems
        1. Linux DOSEMU 1.2.0
        2. FreeDOS native mode
        3. M$DOS Windows box
        4. M$DOS native mode
        Hardwares
        VGA, CGA, MONO


PACKAGE (version 1.12) PG112.ZIP
        BIN\PG.MAN            - Manual (this file)
        BIN\PG.EXE            - the program
        BIN\SVHEX.COM         - Plugin binary (hex)
        BIN\SVTXT.COM         - Plugin binary (text)
        SOURCE\PG\PG.C        - C source program
        SOURCE\PG\PG.H        - C header
        SOURCE\PG\PGASM.ASM   - assembly subroutines
        SOURCE\PG\PG.MAK      - make file for Turbo C 2.01
        SOURCE\PG\SVHEX.ASM   - Plugin source file (hex)
        SOURCE\PG\SVTXT.ASM   - Plugin source file (text)
        DOC\PG\NEWS           - anouncement
        DOC\PG\TO_DO          - job list
        DOC\PG\COPYING        - GNU GPL copyright


INSTALL PG (version 1.12)

        To compile PG you need:
        1. Borland Turbo C 2.01
        2. Nasm 0.98.xx

        Type:
            tcc -c pg.c
            nasm -f obj pgasm.asm -o pgasm.obj
            tlink lib\c0s pg pgasm,pg,,lib\cs

        This will generate the PG.EXE program.


        or
            d:\>make -fpg.mak -Dtc=Turbo_C_Directory


        Should you get any error, check if the path is correct
        in "PG.MAK".  Also read message from previous maintainer
        at the last section of this manual.
        Keep plugins in your path, and PG.MAN in the same directory
        as PG.EXE


Programming Resources

        PG 1.12 -- Turbo C with Nasm
          Borland Turbo C 2.01
          NASM 0.98
          Insight 1.10

        Turbo C 2.01 is available at the Borland Software Museum.
          http://community.borland.com/museum/

        Nasm 0.98.xx is available at
          http://nasm.sourceforge.net/

        Insight 1.10
          http://www.freedos.org/


Limitations
        PLUGINS cannot handle file size > 64K


About Plugins
        PG employs plugins to achieve extra capablities such as
        on line help, long line wrapping, hexidecimal view.
        Plugins are separate programs 0.8k each, tiny, simple
        yet support piping. Plugins are invoked with the F1,
        h,H,w,W key, and exit with exactly the same key. Plugins
        synchronize the position of the file with PG. To navigate
        with Up, Down, Page Up, Page Down, Home, End keys and
        exit with ESC. Keep plugins together with PG.EXE and PG.MAN
        in a %PATH% directory.


Author  Bill Weinmen
        E-mail : wew@bearnet.com
        BAHCL (plugins)

Maintainer  BAHCL
        version : 1.12 ... 1.02
        E-mail :


Messages from BAHCL:

        PG has gone a long way to reincarnate itself. It looks
        like it used to be, but action speaks louder than words.
        PG has the power, features, abilities that rivals similar
        text browser in the market, even the M$ realm.

        Previous messages has been moved to the news file.

        I want to express my thanks to the authors of HELPPC, INSIGHT,
        TURBO C, NASM, IBM Tiny Editor. Without their contribution, PG
        may not have made possible.


BAHCL



Messages from previous PG maintainer(s):

============================================================
I have made a few changes to the source, but didn't (technically)
delete anything.  I removed the verbose GNU License statement in the
usage() function.  To put it back in, add this to the code:

   #define SHOW_GNU_COPYING

or, compile like this:

  cc pg.c -fop SHOW_GNU_COPYING=1

============================================================
I have set the default behavior of the program to operate in
mono-mode only.  This is a color scheme that should work well on all
monitors, even a mono display.  To build using Bill's original
colors, add this to the code:

   #define USE_COLOR_MODE

or, compile like this:

  cc pg.c -fop USE_COLOR_MODE=1



============================================================
(Jim Hall, jhall1@isd.net)


